//---------------------------------------------------------------------------
/*
                  Ȉstreambuf  Ver.1.0  by Gimite s
  
  <simple_ostreambuf>
  geՂȏo͗pstreambufBsimple_ostreambuf̔hNXA
  o͂鉼z֐put()I[oCh邾ŗǂBput()͏o͂ɐ
  trueԂ悤ɂBput()̒`͈ȉB
    virtual bool put(const std::string& s);
  
  <simple_istreambuf>
  geՂȓ͗pstreambufBsimple_istreambuf̔hNXA1
  擾鉼z֐get()I[oCh邾ŗǂBget()͓͂̏I[
  ɒBtraits_type::eof()Ԃ悤ɂBget()̒`͈ȉB
    virtual int get();
  ߂(unget)Ήz֐unget()I[oChB

  simple_ostreambufAsimple_istreambuf͓o͂̃obt@OsȂB
  
*/
//---------------------------------------------------------------------------
#ifndef GIMITE_simple_streambufH
#define GIMITE_simple_streambufH
//---------------------------------------------------------------------------
#include <ios>//streamsize
#include <streambuf>//basic_streambuf
#include <string>//char_traits, basic_string
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
template<class charT, class traits= std::char_traits<charT> >
class basic_simple_ostreambuf: public std::basic_streambuf<charT, traits>
{
  typedef std::basic_streambuf<charT, traits> streambuf_type;
  typedef std::basic_string<charT, traits> string_type;

public:
  typedef streambuf_type::int_type int_type;
  typedef streambuf_type::char_type char_type;

protected:
  //sóAȂtrue
  virtual bool put(const string_type& s)= 0;
  
  virtual int_type overflow(int_type c= traits::eof()){
    if (traits::eq_int_type(c, traits::eof())) return c;
    else return put(string_type(1, c))? c:traits::eof();
  }
  virtual std::streamsize xsputn(const char_type* s, std::streamsize n){
    return put(string_type(s, n))? n:0;
  }

};

typedef basic_simple_ostreambuf<char> simple_ostreambuf;
typedef basic_simple_ostreambuf<wchar_t> simple_wostreambuf;
//---------------------------------------------------------------------------
template<class charT, class traits= std::char_traits<charT> >
class basic_simple_istreambuf: public std::basic_streambuf<charT, traits>
{
  typedef std::basic_streambuf<charT, traits> streambuf;

public:
  typedef typename streambuf::int_type int_type;

  basic_simple_istreambuf(){
    for (int i= 0; i<3; ++i) buffer_[i]= traits::eof();
  }

protected:
  //1擾Atraits_type::eof()
  virtual int_type get()= 0;
  //c߂AȂtrue
  virtual bool unget(charT c){return false;}
  
  //1ǂݏoAǂݏoʒui߂
  virtual int_type uflow(){
    int_type res= underflow();
    buffer_[0]= buffer_[1];
    buffer_[1]= buffer_[2];
    buffer_[2]= traits::eof();
    return res;
  }
  //1ǂݏoiǂݏoʒuςȂj
  virtual int_type underflow(){
    if (is_eof(buffer_[1])) buffer_[1]= get();
    return buffer_[1];
  }
  //obt@1߂
  virtual int_type pbackfail(int_type c= traits_type::eof()){
    if (!is_eof(buffer_[2]) || (is_eof(buffer_[0]) && is_eof(c)))
      return traits::eof();
    if (!is_eof(buffer_[1]) || !unget(is_eof(c)? buffer_[0]:c)){
      buffer_[2]= buffer_[1];
      buffer_[1]= is_eof(c)? buffer_[0]:c;
    }
    buffer_[0]= traits::eof();
    return buffer_[1];
  }
  virtual int showmanyc(){return -1;}

private:
  int_type buffer_[3];//*1
  
  bool is_eof(int_type c){return traits::eq_int_type(c, traits::eof());}

};

//*1  0:oςݕ  1:ǂݏoΏ  2:̎Ɏo

typedef basic_simple_istreambuf<char> simple_istreambuf;
typedef basic_simple_istreambuf<wchar_t> simple_wistreambuf;
//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
