//---------------------------------------------------------------------------
/*
                R}hCp[T 1.0  by Gimite s

  UNIXR}hIȃAvP[V₷悤ɃR}hC
  NXBɃIvV܂B
  IvViex. --loginjɂ͑ΉĂ܂񂪁A̕w肪ȒP
  B
  
  arg_parser(int argc, char** argv, const char* arg_options= "", 
      char option_c= '-', char out_option= 'o');
    RXgN^B
    argc, argv:  main()֐argcAargv̂܂ܓnB
    arg_options: IvViex. -I/usr/includejׂB
                 ex. -I-LȂ"IL"B
    option_c:    IvV̐擪B
    out_option:  o͐t@Cw肷IvVBout()ŎgpB
                 gp邽߂ɂarg_optionsɊ܂܂ĂKvB
    
  bool has_option(char c)const;
    IvVcw肳Ă邩ԂB
    
  std::string option_arg(char c)const;
    IvVc̈B

  std::string normal_argv(int n)const;
    IvVȊOnԖڂ̈B0n܂̂ŒӁB
    
  int normal_argc()const;
    IvVȊÖ̐BAvP[V͊܂܂ȂB
    
  std::istream& in();
    IvVȊO̍ŏ̈wt@CifstreamBꂪcinB
  
  std::ostream& out();
    o͐t@CIvVŎw肳ꂽt@CofstreamBꂪ
    coutB
    
  ΉR}hC̗܂B-c͈IvVƂ
    ܂B2͓łB
  -a -b -cFoo input.txt
  -ab input.txt -c Foo

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_arg_parserH
#define GIMITE_arg_parserH
//---------------------------------------------------------------------------
#include <string>//string
#include <cstddef>//size_t
#include <map>//map
#include <vector>//vector
#include <fstream>//fstream
#include <memory>//auto_ptr
#include <iterator>//iterator_traits
#include <cstring>//strchr
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
class arg_parser
{
public:
  arg_parser(int argc, char** argv, const char* arg_options= "",
    char option_c= '-', char out_option= 'o');
  template <class InputIterator>
  arg_parser(InputIterator first, InputIterator last,
  		const char* arg_options= "", char option_c= '-', char out_option= 'o'){
  	typedef typename std::iterator_traits<InputIterator>
    	::value_type::size_type size_type;
    char prev_opt= '\0';
    for (InputIterator it= first; it!=last; ++it){
      if (it->length()>0 && (*it)[0]==option_c){
        for (size_type pos= 1; pos<it->length(); ++pos){
          char c= (*it)[pos];
          opt_map_[c]= std::string();
          if (std::strchr(arg_options, c)){
            if ((*it)[++pos]) opt_map_[c]= it->substr(pos);
            else prev_opt= c;
            break;
          }
        }
      }else{
        if (prev_opt)
          opt_map_[prev_opt]= *it;
        else
          normal_args_.push_back(*it);
        prev_opt= '\0';
      }
    }
  }
  bool has_option(char c)const{
    return opt_map_.count(c);
  }
  std::string option_arg(char c)const{
    opt_map_t::const_iterator it= opt_map_.find(c);
    if (it==opt_map_.end()) return std::string();
    else return it->second;
  }
  std::string normal_argv(int n)const{
    return normal_args_[n];
  }
  int normal_argc()const{
    return normal_args_.size();
  }
  std::istream& in();
  std::ostream& out();

private:
  typedef std::map<char, std::string> opt_map_t;

  opt_map_t opt_map_;
  std::vector<std::string> normal_args_;
  std::auto_ptr<std::ifstream> pin_;
  std::auto_ptr<std::ofstream> pout_;
  char out_option_;

};

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

