//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <memory>
#include "MultiLineEditForm.h"
#include "Option.h"
#include "MainForm.h"
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMultiLineEdit *frmMultiLineEdit;
//---------------------------------------------------------------------------
__fastcall TfrmMultiLineEdit::TfrmMultiLineEdit(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
std::string TfrmMultiLineEdit::EditEscapedText(const std::string& sTitle,
    const std::string& sEdited)
  //s"\\n"ɂȂĂeLXgҏWāǍʂԂB
{

  TOption* opt= frmMain->DevasApp()->Option();
  if (!opt->Escape() || opt->ByLine()){
    if (Application->MessageBox(
        "sҏWɂ́AIvV\n"
        "[\\nA\\tȂǂg]ONA[sPʂŌ]OFF\n"
        "Kv܂B̃IvVݒ肵܂H",
        "Devas", MB_YESNO | MB_ICONINFORMATION) == IDYES){
      opt->SetEscape(true);
      opt->SetByLine(false);
      frmMain->OnOptionChanged();
    }else{
      return sEdited;
    }
  }

  auto_ptr<TfrmMultiLineEdit> frm(new TfrmMultiLineEdit(NULL));
  frm->Caption= sTitle.c_str();
  frm->memMain->Text= UnescapeMultiLine(sEdited).c_str();
  frm->memMain->SelLength= frm->memMain->Text.Length();
  frm->ShowModal();
  return EscapeMultiLine(frm->memMain->Text.c_str());

}

//---------------------------------------------------------------------------

