//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include "ReplacingPattern.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
TAbstractReplacingPattern*
    TAbstractReplacingPattern::NewReplacingPattern(const TReplaceInfo& info)
  //w̏𖞂up^[
{
	babel::init_babel();
  if (info.mode_==smRegex){
    if (info.bMultiByte_)
    	return new TRegexReplacingPattern<wchar_t>(
      	babel::sjis_to_unicode(info.sReplacing_));
    else
    	return new TRegexReplacingPattern<char>(info.sReplacing_);
  }else{
    if (info.bMultiByte_){
    	wstring ws= babel::sjis_to_unicode(info.sReplacing_);
      if (info.bEscape_) ws= Unescape(ws);
    	return new TNormalReplacingPattern<wchar_t>(ws);
    }else{
    	string s= info.sReplacing_;
      if (info.bEscape_) s= Unescape(s);
    	return new TNormalReplacingPattern<char>(s);
    }
  }
}

//---------------------------------------------------------------------------
