//---------------------------------------------------------------------------
/*
                R}hCp[T 1.1  by Gimite s

  UNIXR}hIȃAvP[V₷悤ɃR}hC
  NXBɃIvV܂B
  IvViex. --loginjɂ͑ΉĂ܂񂪁A̕w肪ȒP
  B
  
  *RXgN^
  
  arg_parser(int argc, char** argv, const char* arg_options= "", 
      char option_c= '-', char out_option= 'o');
    RXgN^B
    argc, argv:  main()֐argcAargv̂܂ܓnBargv[0]͖B
    arg_options: IvViex. -I/usr/includejׂB
                 ex. -I-LȂ"IL"B
    option_c:    IvV̐擪B
    out_option:  o͐t@Cw肷IvVBout()ŎgpB
                 gp邽߂ɂarg_optionsɊ܂܂ĂKvB
    
  arg_parser(const std::vector<std::string>& args, const char* arg_options= "", 
      char option_c= '-', char out_option= 'o');
    RXgN^B
    args:        R}hCB1Ԗڂ̌`ƈႢAargs[0]͖
    						 Ȃ̂ŒӁB
    c:        1Ԗڂ̌`̃RXgN^ƓB
    
  *IvV擾
  
  bool has_option(char c)const;
    IvVcw肳Ă邩ԂB
    
  int option_count(char c)const;
    IvVcw肳Ă邩ԂB
    
  std::string option_arg(char c, int n= 0)const;
    IvVc̈B
    IvVw肳ꂽꍇiex. -L/lib -L/usr/libj́Anw
    nԖځi擪0j̈擾łB
	
	std::vector<std::string> option_args(char c)const;
		IvVc̑SĂ̈vectorŕԂB
	
	*IvVȊÖ̎擾
	
  int normal_argc()const;
    IvVȊÖ̐BAvP[Viargv[0]j͊܂܂ȂB
  
  std::string normal_argv(int n)const;
    IvVȊOnԖڂ̈B0n܂̂ŒӁB
  
  std::vector<std::string> normal_args()const;
    IvVȊȎSĂ̈vectorŕԂB
    
  *o̓Xg[̎擾
  
  std::istream& in();
    IvVȊO̍ŏ̈wt@CifstreamBꂪcinB
  
  std::ostream& out();
    o͐t@CIvViftHgł"-o"Ŏw肳ꂽt@C
    ofstreamBꂪcoutB
    
  ΉR}hC̗܂B-c͈IvVƂ
    ܂B2͓ӖɂȂ܂B
    
    -a -b -cFoo input.txt
    -ab input.txt -c Foo

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_arg_parserH
#define GIMITE_arg_parserH
//---------------------------------------------------------------------------
#include <string>//string
#include <cstddef>//size_t
#include <map>//map
#include <vector>//vector
#include <fstream>//fstream
#include <memory>//auto_ptr
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
class arg_parser
{
public:
	typedef std::vector<std::string> strings_t;

	arg_parser(int argc, char** argv, const char* arg_options= "",
		char option_c= '-', char out_option= 'o');
	arg_parser(const strings_t& args, const char* arg_options= "",
		char option_c= '-', char out_option= 'o');
	bool has_option(char c)const{
		return opt_map_.count(c);
	}
	int option_count(char c)const{
		return has_option(c) ? opt_map_.find(c)->second.size() : 0;
	}
	std::string option_arg(char c, int n= 0)const{
		return (n>=0 && n<option_count(c)) ?
			option_args(c)[n] : string();
	}
	strings_t option_args(char c)const{
		return has_option(c) ? opt_map_.find(c)->second : strings_t();
	}
	int normal_argc()const{
		return normal_args_.size();
	}
	std::string normal_argv(int n)const{
		return (n>=0 && n<int(normal_args_.size())) ?
			normal_args_[n] : std::string();
	}
	strings_t normal_args()const{
		return normal_args_;
	}
	std::istream& in();
  std::ostream& out();
  
private:
  typedef std::map<char, std::vector<std::string> > opt_map_t;

  opt_map_t opt_map_;
	strings_t normal_args_;
  std::auto_ptr<std::ifstream> pin_;
  std::auto_ptr<std::ofstream> pout_;
  char out_option_;
  
	void set_args(const strings_t& args,
  	const char* arg_options, char option_c);

};

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

